{
  var fs = require('fs');
  var launcher = require("openurl");
  var https = require('https');
  var httpProxy = require('http-proxy');
  var certPath = (__dirname || '') + '/certs/';
  var srvr;
  var proxy = httpProxy.createProxy();
  var credentials = {
    key: fs.readFileSync(certPath + 'proxyKey.pem', 'utf8'),
    cert: fs.readFileSync(certPath + 'proxyCert.pem', 'utf8')
  };
  var curTarget;

  var defaultOptions = {
    home_port: 2109,
    debug: false,
    proxyReq: function () {
    },
    proxyRes: function () {
    }
  };
  var options;

  var printMe = function (val) {
    if (!options.debug) {
      return;
    }
    console.log(val);
  };

  proxy.on('proxyReq', function (proxyReq, req, res) {
    options.proxyReq.apply(options.proxyReq, arguments);
  });

  proxy.on('proxyRes', function (proxyRes, req, res) {
    options.proxyRes.apply(options.proxyReq, arguments);
  });

  function start(userOptions) {
    if(srvr){
      return;
    }
    options = Object.assign(defaultOptions, userOptions);
    printMe('Starting proxy');

    srvr = https.createServer(credentials, function (req, res) {
      Object.keys(options.routingTable).some(function (key) {
        const regX = new RegExp(key);
        if (regX.test(req.url)) {
          var strm = req.url + ' => ' + (options.routingTable[key].targetName || options.routingTable.target);
          userOptions.info && userOptions.info(strm);
          printMe(strm);
          proxy.web(req, res, options.routingTable[key]);
          curTarget = options.routingTable[key];
          return true;
        }
      });
    }).listen(options.home_port);
    if (options.startPath) {
      launcher.open('https://localhost:' + options.home_port + '/' + options.startPath);
    }
  }

  function stop() {
    srvr && srvr.close();
    srvr = null;
  }
}
module.exports = {
  start: start,
  stop: stop
};